Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2528)
@@ -21,4 +21,6 @@
    USE iom
    USE trcdta
+   USE lib_mpp
+   USE lib_fortran
 
    IMPLICIT NONE
@@ -118,35 +120,20 @@
       IF(lwp)  WRITE(numout,*)
 
-      IF( cp_cfg == "orca" .AND. .NOT. lk_trc_c1d ) THEN      ! ORCA condiguration (not 1D) !
+      IF( cp_cfg == "orca" .AND. .NOT. lk_c1d ) THEN      ! ORCA condiguration (not 1D) !
          !                                                    ! --------------------------- !
          ! set total alkalinity, phosphate, nitrate & silicate
 
-         zalksum = 0.e0
-         zpo4sum = 0.e0
-         zno3sum = 0.e0
-         zsilsum = 0.e0
-         DO jk = 1, jpk
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zvol = cvol(ji,jj,jk)
-#  if defined key_off_degrad
-                  zvol = zvol * facvol(ji,jj,jk)
-#  endif
-                  zalksum = zalksum + trn(ji,jj,jk,jptal) * zvol
-                  zpo4sum = zpo4sum + trn(ji,jj,jk,jppo4) * zvol
-                  zno3sum = zno3sum + trn(ji,jj,jk,jpno3) * zvol
-                  zsilsum = zsilsum + trn(ji,jj,jk,jpsil) * zvol
-               END DO
-            END DO
-         END DO
-         IF( lk_mpp )   CALL mpp_sum( zalksum )     ! sum over the global domain
-         IF( lk_mpp )   CALL mpp_sum( zpo4sum )     ! sum over the global domain
-         IF( lk_mpp )   CALL mpp_sum( zno3sum )     ! sum over the global domain
-         IF( lk_mpp )   CALL mpp_sum( zsilsum )     ! sum over the global domain
          zarea   = 1. / areatot * 1.e6
-         zalksum = zalksum * zarea
-         zpo4sum = zpo4sum * zarea / 122.
-         zno3sum = zno3sum * zarea / 7.6
-         zsilsum = zsilsum * zarea
+# if defined key_degrad
+         zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:) * facvol(:,:,:) ) * zarea
+         zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:) * facvol(:,:,:) ) * zarea / 122.
+         zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:) * facvol(:,:,:) ) * zarea / 7.6
+         zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:) * facvol(:,:,:) ) * zarea
+# else
+         zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:)  ) * zarea
+         zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:)  ) * zarea / 122.
+         zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:)  ) * zarea / 7.6
+         zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:)  ) * zarea
+# endif
 
          IF(lwp) WRITE(numout,*) '       TALK mean : ', zalksum
@@ -263,5 +250,5 @@
 #if defined key_dtatrc
       ! Restore close seas values to initial data
-      CALL trc_dta( nittrc000 ) 
+      CALL trc_dta( nit000 ) 
       DO jn = 1, jptra
          IF( lutini(jn) ) THEN
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2528)
@@ -22,10 +22,20 @@
    USE p4zche          ! 
    USE p4zbio          ! 
+   USE p4zsink         ! 
+   USE p4zopt          ! 
+   USE p4zlim          ! 
+   USE p4zprod         !
+   USE p4zmort         !
+   USE p4zmicro        ! 
+   USE p4zmeso         ! 
+   USE p4zrem          ! 
    USE p4zsed          ! 
    USE p4zlys          ! 
    USE p4zflx          ! 
 
-   USE trdmld_trc_oce
-   USE trdmld_trc
+   USE prtctl_trc
+
+   USE trdmod_oce
+   USE trdmod_trc
 
    USE sedmodel
@@ -37,7 +47,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -59,11 +69,16 @@
       INTEGER ::   jnt, jn
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrpis   ! used for pisces sms trends
+      CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
-      IF( kt == nittrc000  .AND. .NOT. ln_rsttr )   CALL trc_sms_pisces_init    ! Initialization (first time-step only)
+      IF( kt == nit000 )   CALL trc_sms_pisces_init    ! Initialization (first time-step only)
 
-      IF( ndayflxtr /= nday ) THEN      ! New days
+      IF( ndayflxtr /= nday_year ) THEN      ! New days
          !
-         ndayflxtr = nday
+         ndayflxtr = nday_year
+
+         IF(lwp) write(numout,*)
+         IF(lwp) write(numout,*) ' New chemical constants and various rates for biogeochemistry at new day : ', nday_year
+         IF(lwp) write(numout,*) '~~~~~~'
 
          CALL p4z_che          ! computation of chemical constants
@@ -71,5 +86,4 @@
          !
       ENDIF
-
 
       DO jnt = 1, nrdttrc          ! Potential time splitting if requested
@@ -91,8 +105,9 @@
       END DO
 
+
       IF( l_trdtrc ) THEN
           DO jn = jp_pcs0, jp_pcs1
             ztrpis(:,:,:) = tra(:,:,:,jn)
-            CALL trd_mod_trc( ztrpis, jn, jptrc_trd_sms, kt )   ! save trends
+            CALL trd_mod_trc( ztrpis, jn, jptra_trd_sms, kt )   ! save trends
           END DO
       END IF
@@ -121,18 +136,38 @@
       REAL(wp) ::  ztmas, ztmas1
 
-      ! Initialization of chemical variables of the carbon cycle
-      ! --------------------------------------------------------
-      DO jk = 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ztmas   = tmask(ji,jj,jk)
-               ztmas1  = 1. - tmask(ji,jj,jk)
-               zcaralk = trn(ji,jj,jk,jptal) - borat(ji,jj,jk) / (  1. + 1.E-8 / ( rtrn + akb3(ji,jj,jk) )  )
-               zco3    = ( zcaralk - trn(ji,jj,jk,jpdic) ) * ztmas + 0.5e-3 * ztmas1
-               zbicarb = ( 2. * trn(ji,jj,jk,jpdic) - zcaralk )
-               hi(ji,jj,jk) = ( ak23(ji,jj,jk) * zbicarb / zco3 ) * ztmas + 1.e-9 * ztmas1
+      IF( .NOT. ln_rsttr ) THEN
+         ! Initialization of chemical variables of the carbon cycle
+         ! --------------------------------------------------------
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztmas   = tmask(ji,jj,jk)
+                  ztmas1  = 1. - tmask(ji,jj,jk)
+                  zcaralk = trn(ji,jj,jk,jptal) - borat(ji,jj,jk) / (  1. + 1.E-8 / ( rtrn + akb3(ji,jj,jk) )  )
+                  zco3    = ( zcaralk - trn(ji,jj,jk,jpdic) ) * ztmas + 0.5e-3 * ztmas1
+                  zbicarb = ( 2. * trn(ji,jj,jk,jpdic) - zcaralk )
+                  hi(ji,jj,jk) = ( ak23(ji,jj,jk) * zbicarb / zco3 ) * ztmas + 1.e-9 * ztmas1
+               END DO
             END DO
          END DO
-      END DO
+         !
+      END IF
+
+      ! Time step duration for biology
+      xstep = rfact2 / rday
+
+      CALL p4z_sink_init      ! vertical flux of particulate organic matter
+      CALL p4z_opt_init       ! Optic: PAR in the water column
+      CALL p4z_lim_init       ! co-limitations by the various nutrients
+      CALL p4z_prod_init      ! phytoplankton growth rate over the global ocean. 
+      CALL p4z_rem_init       ! remineralisation
+      CALL p4z_mort_init      ! phytoplankton mortality
+      CALL p4z_micro_init     ! microzooplankton
+      CALL p4z_meso_init      ! mesozooplankton
+      CALL p4z_sed_init       ! sedimentation
+      CALL p4z_lys_init       ! calcite saturation
+      CALL p4z_flx_init       ! gas exchange
+
+      ndayflxtr = 0
 
    END SUBROUTINE trc_sms_pisces_init
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/par_sed.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/par_sed.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/par_sed.F90	(revision 2528)
@@ -16,4 +16,6 @@
       jpjm1    =>   jpjm1 ,  & !: jpj - 1
       jpij     =>   jpij       !: jpi x jpj
+      jp_tem   =>   jp_tem     !: indice of temperature
+      jp_sal   =>   jp_sal     !: indice of salintity
 
 #if ! defined key_sed_off
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sed.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sed.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sed.F90	(revision 2528)
@@ -17,5 +17,5 @@
       gphit    =>   gphit  ,  & !: latitude  of t-point (degre)
       e3t_0    =>   e3t_0  ,  & !: reference depth of t-points (m)
-      mbathy   =>   mbathy ,  & !: bathymetry
+      mbkt     =>   mbkt   ,  & !: vertical index of the bottom last T- ocean level
       tmask    =>   tmask  ,  & !: land/ocean mask at t-points
       rdt      =>   rdt         !: time step for the dynamics
@@ -34,10 +34,8 @@
 
    USE oce , ONLY :            &
-      tn      =>    tn    ,  & !: pot. temperature (celsius)
-      sn      =>    sn         !: salinity (psu)
+      tsn      =>    tsn       & !: pot. temperature (celsius) and salinity (psu)
 
    USE trc, ONLY :  &
       trn        , & !: tracer 
-      nittrc000  , & !: 1st time step of tracer model
       nwritetrc      !: outputs frequency of tracer model
 
@@ -215,5 +213,4 @@
    INTEGER, PUBLIC :: &
      numsed = 27
-	
 #else
    !!======================================================================
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedarr.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedarr.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedarr.F90	(revision 2528)
@@ -28,7 +28,7 @@
 
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Header: /home/opalod/NEMOCVSROOT/NEMO/LIM_SRC/limtab.F90,v 1.2 2005/03/27 18:34:42 opalod Exp $ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedchem.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedchem.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedchem.F90	(revision 2528)
@@ -216,5 +216,5 @@
       DO jj = 1,jpj
          DO ji = 1, jpi
-            ikt = MAX( mbathy(ji,jj)-1, 1 )
+            ikt = mbkt(ji,jj) 
             IF ( tmask(ji,jj,ikt) == 1 ) THEN
                zchem_data(ji,jj,1) = ak13 (ji,jj,ikt)
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/seddta.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/seddta.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/seddta.F90	(revision 2528)
@@ -118,5 +118,5 @@
          DO jj = 1,jpj
             DO ji = 1, jpi
-               ikt = MAX( mbathy(ji,jj)-1, 1 )
+               ikt = mbkt(ji,jj)
                IF ( tmask(ji,jj,ikt) == 1 ) THEN
                   trc_data(ji,jj,1)  = trn  (ji,jj,ikt,jptal)
@@ -131,12 +131,12 @@
                   trc_data(ji,jj,9 ) = sinking2(ji,jj,ikt)
                   trc_data(ji,jj,10) = sinkcal (ji,jj,ikt)
-                  trc_data(ji,jj,11) = tn      (ji,jj,ikt)
-                  trc_data(ji,jj,12) = sn      (ji,jj,ikt)
+                  trc_data(ji,jj,11) = tsn     (ji,jj,ikt,jp_tem)
+                  trc_data(ji,jj,12) = tsn     (ji,jj,ikt,jp_sal)
 #   else
                   trc_data(ji,jj,7 ) = sinksil (ji,jj,ikt)
                   trc_data(ji,jj,8 ) = sinking (ji,jj,ikt)
                   trc_data(ji,jj,9 ) = sinkcal (ji,jj,ikt)
-                  trc_data(ji,jj,10) = tn      (ji,jj,ikt)
-                  trc_data(ji,jj,11) = sn      (ji,jj,ikt)       
+                  trc_data(ji,jj,10) = tsn     (ji,jj,ikt,jp_tem)
+                  trc_data(ji,jj,11) = tsn     (ji,jj,ikt,jp_sal)       
 #   endif
                ENDIF
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90	(revision 2528)
@@ -123,5 +123,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            ikt = MAX( INT( sbathy(ji,jj) )  - 1, 1 )
+            ikt = MAX( INT( sbathy(ji,jj) ), 1 )
             IF( tmask(ji,jj,ikt) == 1 ) epkbot(ji,jj) = zdta(ji,jj)
          ENDDO
@@ -135,5 +135,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            ikt = MAX( mbathy(ji,jj) - 1, 1 )
+            ikt = mbkt(ji,jj) 
             IF( tmask(ji,jj,ikt) == 1 ) epkbot(ji,jj) = e3t_0(ikt)
          ENDDO
@@ -443,11 +443,9 @@
 
       dtsed = rdt
+      nitsed000 = nit000
+      nitsedend = nitend
 #if ! defined key_sed_off
-      nitsed000 = nittrc000
-      nitsedend = nitend
       nwrised   = nwritetrc
 #else
-      nitsed000 = nit000
-      nitsedend = nitend
       nwrised   = nwrite
 #endif
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedsfc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedsfc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedsfc.F90	(revision 2528)
@@ -52,5 +52,5 @@
       DO jj = 1,jpj
          DO ji = 1, jpi
-            ikt = MAX( mbathy(ji,jj)-1, 1 )
+            ikt = mbkt(ji,jj)
             IF ( tmask(ji,jj,ikt) == 1 ) THEN
                trn(ji,jj,ikt,jptal) = trc_data(ji,jj,1)
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedwri.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedwri.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedwri.F90	(revision 2528)
@@ -186,5 +186,5 @@
          CALL histbeg ( clhstnam, jpi, glamt, jpj, gphit,     &
             &             iimi, iima-iimi+1, ijmi, ijma-ijmi+1,         &
-            &             nitsed000-1, zjulian, zdt,  nhorised, nised , domain_id=nidom )
+            &             nitsed000-1, zjulian, zdt,  nhorised, nised , domain_id=nidom, snc4chunks=snc4set )
          CALL histvert( nised,'deptht','Vertic.sed.T levels','m',ipk, profsed, ndepsed, 'down' )
          CALL wheneq  ( jpi*jpj*ipk, tmasksed, 1, 1., ndext52, ndimt52 )
@@ -223,5 +223,5 @@
 
 
-         CALL histend( nised )
+         CALL histend( nised, snc4set )
 
          WRITE(numsed,*)
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2528)
@@ -0,0 +1,184 @@
+MODULE trcadv
+   !!==============================================================================
+   !!                       ***  MODULE  trcadv  ***
+   !! Ocean passive tracers:  advection trend 
+   !!==============================================================================
+   !! History :  2.0  !  05-11  (G. Madec)  Original code
+   !!            3.0  !  10-06  (C. Ethe)   Adapted to passive tracers
+   !!----------------------------------------------------------------------
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   trc_adv      : compute ocean tracer advection trend
+   !!   trc_adv_ctl  : control the different options of advection scheme
+   !!----------------------------------------------------------------------
+   USE oce_trc         ! ocean dynamics and active tracers
+   USE trc             ! ocean passive tracers variables
+   USE trcnam_trp      ! passive tracers transport namelist variables
+   USE traadv_cen2     ! 2nd order centered scheme (tra_adv_cen2   routine)
+   USE traadv_tvd      ! TVD      scheme           (tra_adv_tvd    routine)
+   USE traadv_muscl    ! MUSCL    scheme           (tra_adv_muscl  routine)
+   USE traadv_muscl2   ! MUSCL2   scheme           (tra_adv_muscl2 routine)
+   USE traadv_ubs      ! UBS      scheme           (tra_adv_ubs    routine)
+   USE traadv_qck      ! QUICKEST scheme           (tra_adv_qck    routine)
+   USE traadv_eiv      ! eddy induced velocity     (tra_adv_eiv    routine)
+   USE ldftra_oce      ! lateral diffusion coefficient on tracers
+   USE in_out_manager  ! I/O manager
+   USE prtctl_trc          ! Print control
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   trc_adv    ! routine called by step module
+
+   INTEGER ::   nadv   ! choice of the type of advection scheme
+   REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
+      !                                ! except at nit000 (=rdttra) if neuler=0
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE trc_adv( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_adv  ***
+      !!
+      !! ** Purpose :   compute the ocean tracer advection trend.
+      !!
+      !! ** Method  : - Update the tracer with the advection term following nadv
+      !!----------------------------------------------------------------------
+      !!
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      !
+      INTEGER :: jk 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zun, zvn, zwn   ! effective velocity
+      CHARACTER (len=22) :: charout
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 )   CALL trc_adv_ctl          ! initialisation & control of options
+
+#if ! defined key_pisces
+      IF( neuler == 0 .AND. kt == nit000 ) THEN     ! at nit000
+         r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
+      ELSEIF( kt <= nit000 + nn_dttrc ) THEN          ! at nit000 or nit000+1
+         r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+      ENDIF
+#else
+      r2dt(:) =  rdttrc(:)              ! = rdttrc (for PISCES use Euler time stepping)
+#endif
+
+      !                                                   ! effective transport
+      DO jk = 1, jpkm1
+         !                                                ! eulerian transport only
+         zun(:,:,jk) = e2u(:,:) * fse3u(:,:,jk) * un(:,:,jk)
+         zvn(:,:,jk) = e1v(:,:) * fse3v(:,:,jk) * vn(:,:,jk)
+         zwn(:,:,jk) = e1t(:,:) * e2t(:,:)      * wn(:,:,jk)
+         !
+      END DO
+      zwn(:,:,jpk) = 0.e0                                 ! no transport trough the bottom
+
+      !                                                   ! add the eiv transport (if necessary)
+      IF( lk_traldf_eiv )   CALL tra_adv_eiv( kt, zun, zvn, zwn, 'TRC' )
+      !
+      SELECT CASE ( nadv )                            !==  compute advection trend and add it to general trend  ==!
+      CASE ( 1 )   ;    CALL tra_adv_cen2  ( kt, 'TRC',       zun, zvn, zwn, trb, trn, tra, jptra )   !  2nd order centered
+      CASE ( 2 )   ;    CALL tra_adv_tvd   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  TVD 
+      CASE ( 3 )   ;    CALL tra_adv_muscl ( kt, 'TRC', r2dt, zun, zvn, zwn, trb,      tra, jptra )   !  MUSCL 
+      CASE ( 4 )   ;    CALL tra_adv_muscl2( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  MUSCL2 
+      CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  UBS 
+      CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )   !  QUICKEST 
+      !
+      CASE (-1 )                                      !==  esopa: test all possibility with control print  ==!
+         CALL tra_adv_cen2  ( kt, 'TRC',       zun, zvn, zwn, trb, trn, tra, jptra )          
+         WRITE(charout, FMT="('adv1')")  ; CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         CALL tra_adv_tvd   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
+         WRITE(charout, FMT="('adv2')")  ; CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         CALL tra_adv_muscl ( kt, 'TRC', r2dt, zun, zvn, zwn, trb,      tra, jptra )          
+         WRITE(charout, FMT="('adv3')")  ; CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         CALL tra_adv_muscl2( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
+         WRITE(charout, FMT="('adv4')")  ; CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         CALL tra_adv_ubs   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
+         WRITE(charout, FMT="('adv5')")  ; CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         CALL tra_adv_qck   ( kt, 'TRC', r2dt, zun, zvn, zwn, trb, trn, tra, jptra )          
+         WRITE(charout, FMT="('adv6')")  ; CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm,clinfo2='trd')
+         !
+      END SELECT
+
+      !                                              ! print mean trends (used for debugging)
+      IF( ln_ctl )   THEN
+         WRITE(charout, FMT="('adv ')")  ;  CALL prt_ctl_trc_info(charout)
+                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+      END IF
+      !
+   END SUBROUTINE trc_adv
+
+
+   SUBROUTINE trc_adv_ctl
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_adv_ctl  ***
+      !!                
+      !! ** Purpose : Control the consistency between namelist options for 
+      !!              passive tracer advection schemes and set nadv
+      !!----------------------------------------------------------------------
+      INTEGER ::   ioptio
+      !!----------------------------------------------------------------------
+
+      ioptio = 0                      ! Parameter control
+      IF( ln_trcadv_cen2   )   ioptio = ioptio + 1
+      IF( ln_trcadv_tvd    )   ioptio = ioptio + 1
+      IF( ln_trcadv_muscl  )   ioptio = ioptio + 1
+      IF( ln_trcadv_muscl2 )   ioptio = ioptio + 1
+      IF( ln_trcadv_ubs    )   ioptio = ioptio + 1
+      IF( ln_trcadv_qck    )   ioptio = ioptio + 1
+      IF( lk_esopa         )   ioptio =          1
+
+      IF( ioptio /= 1 )   CALL ctl_stop( 'Choose ONE advection scheme in namelist namtrc_adv' )
+
+      !                              ! Set nadv
+      IF( ln_trcadv_cen2   )   nadv =  1
+      IF( ln_trcadv_tvd    )   nadv =  2
+      IF( ln_trcadv_muscl  )   nadv =  3
+      IF( ln_trcadv_muscl2 )   nadv =  4
+      IF( ln_trcadv_ubs    )   nadv =  5
+      IF( ln_trcadv_qck    )   nadv =  6
+      IF( lk_esopa         )   nadv = -1
+
+      IF(lwp) THEN                   ! Print the choice
+         WRITE(numout,*)
+         IF( nadv ==  1 )   WRITE(numout,*) '         2nd order scheme is used'
+         IF( nadv ==  2 )   WRITE(numout,*) '         TVD       scheme is used'
+         IF( nadv ==  3 )   WRITE(numout,*) '         MUSCL     scheme is used'
+         IF( nadv ==  4 )   WRITE(numout,*) '         MUSCL2    scheme is used'
+         IF( nadv ==  5 )   WRITE(numout,*) '         UBS       scheme is used'
+         IF( nadv ==  6 )   WRITE(numout,*) '         QUICKEST  scheme is used'
+         IF( nadv == -1 )   WRITE(numout,*) '         esopa test: use all advection scheme'
+      ENDIF
+      !
+   END SUBROUTINE trc_adv_ctl
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option                                         Empty module
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_adv( kt )
+      INTEGER, INTENT(in) :: kt
+      WRITE(*,*) 'trc_adv: You should not have seen this print! error?', kt
+   END SUBROUTINE trc_adv
+#endif
+  !!======================================================================
+END MODULE trcadv
